<?php
class ControllerModuleTradeevo extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/tradeevo');

		$this->document->setTitle($this->language->get('heading_title_unstiled'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('tradeevo', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		

		$data['entry_status'] = $this->language->get('entry_status');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/tradeevo', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('module/tradeevo', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);



		if (isset($this->request->post['tradeevo_status'])) {
			$data['tradeevo_status'] = $this->request->post['tradeevo_status'];
		} else {
			$data['tradeevo_status'] = $this->config->get('tradeevo_status');
		}
		
		if (isset($this->request->post['tradeevo_public_key'])) {
			$data['tradeevo_public_key'] = $this->request->post['tradeevo_public_key'];
		} else {
			$data['tradeevo_public_key'] = $this->config->get('tradeevo_public_key');
		}
		
		if (isset($this->request->post['tradeevo_private_key'])) {
			$data['tradeevo_private_key'] = $this->request->post['tradeevo_private_key'];
		} else {
			$data['tradeevo_private_key'] = $this->config->get('tradeevo_private_key');
		}

		if (isset($this->request->post['tradeevo_success_order_status_id'])) {
			$data['tradeevo_success_order_status_id'] = $this->request->post['tradeevo_success_order_status_id'];
		} else {
			$data['tradeevo_success_order_status_id'] = $this->config->get('tradeevo_success_order_status_id');
		}

		if (isset($this->request->post['tradeevo_fail_order_status_id'])) {
			$data['tradeevo_fail_order_status_id'] = $this->request->post['tradeevo_fail_order_status_id'];
		} else {
			$data['tradeevo_fail_order_status_id'] = $this->config->get('tradeevo_fail_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$data['categories_feed'] = HTTP_CATALOG . 'index.php?route=module/tradeevo/getCategories';
		$data['products_feed'] = HTTP_CATALOG . 'index.php?route=module/tradeevo/getProducts';
		$data['orders_feed'] = HTTP_CATALOG . 'index.php?route=module/tradeevo/getOrders';
		$data['set_products_feed'] = HTTP_CATALOG . 'index.php?route=module/tradeevo/setProducts';
		$data['set_orders_feed'] = HTTP_CATALOG . 'index.php?route=module/tradeevo/setOrders';
		
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_public_key'] = $this->language->get('text_public_key');
		$data['text_private_key'] = $this->language->get('text_private_key');
		$data['text_categories_feed'] = $this->language->get('text_categories_feed');
		$data['text_products_feed'] = $this->language->get('text_products_feed');
		$data['text_products_feed_help'] = sprintf($this->language->get('text_products_feed_help'), $data['products_feed']);
		$data['text_orders_feed'] = $this->language->get('text_orders_feed');
		$data['text_orders_feed_help'] = sprintf($this->language->get('text_orders_feed_help'), $data['orders_feed'], date('Y-m-d', strtotime('-1 week')));
		$data['text_set_products_feed'] = $this->language->get('text_set_products_feed');
		$data['text_set_orders_feed'] = $this->language->get('text_set_orders_feed');
		$data['text_success_order_status_id'] = $this->language->get('text_success_order_status_id');
		$data['text_fail_order_status_id'] = $this->language->get('text_fail_order_status_id');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/tradeevo.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/tradeevo')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}